<template>
  <div>
    <b-table
      :checkable="checkable"
      :focusable="focusable"
      :data="data"
      :columns="columns"
      :paginated="paginated"
      :backend-sorting="true"
      :backend-pagination="true"
      :per-page="perPage"
      :total="total"
      :current-page="currentPage"
      :selected.sync="selected"
      @page-change="pageChange"
      @sort="sortChange"
    />
    {{ selected }}
  </div>
</template>

<script>
  import axios from 'axios'
  import buildQuery from 'odata-query'
  export default {
    props: {
        url: {
          type: String,
          default: ''
        },
        columns: {
          type: Array,
          default: () => []
        },
        paginated: {
          type: Boolean,
          default: true
        },
        perPage: {
          type: Number,
          default: 5
        },
        checkable: {
          type: Boolean,
          default: false
        },
        focusable: {
          type: Boolean,
          default: false
        }
    },
    data() {
      return {
        data: [],
        total: 0,
        currentPage: 1,
        sort: {

        },
        query: '',
        selected: {}
      }
    },
    mounted: function () {
      this.loadData()
    },
    methods: {
      loadData: function () {
        const count = true;
        const top = this.perPage;
        const skip = this.perPage * (this.currentPage - 1);
        const select = this.columns.map(c => c.field);
        this.query = buildQuery({ count, top, 'skip': skip, orderBy: (this.sort.field) ? `${this.sort.field} ${this.sort.order}` : '', select: select})
        axios.get(`${this.url}${this.query}`).then(u => {
          this.data = u.data.value;
          this.total = u.data["@odata.count"]
        })
      },
      sortChange(field, order) {
        this.sort.field = field
        this.sort.order = order
        this.loadData()
      },
      pageChange(page) {
        this.currentPage = page
        this.loadData()
      }
    }
  }
</script>